#ifndef _DISPLAY_HPP
#define _DISPLAY_HPP
    #include "mbed.h"
    #include "General.hpp"
    #include "LCD.hpp"
    
    class Pages{
        public:
            Pages(PinName rs, PinName e, PinName d4, PinName d5, PinName d6, PinName d7) : _lcd(rs,e,d4,d5,d6,d7) {} 
            void INIT();
            void clear();
            void pageOne();
            void pageTwo();
            void pageThree();
						void cursorPos(UINT_16 location);
            
            void setTemperature(S_BYTE temp);
            void setLightLevel(U_BYTE light);
            void setPressure(U_BYTE pres);
            
            void setDateTime(char* dateTime);
        private:
            char _temperature[4];
            char _lightLevel[5];
            char _pressure[6];
        private:
            LCD _lcd;
    };
#endif

